{
my number is 06

This file includes source code of Client application

this file needs _06Shared unit
}
unit _06CntMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, _06Shared;

type
  TStatus=(sWaiting,sKill);
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Client: TClientSocket;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
   Port:Word;
   Status:TStatus;                //good for killing process only
   MyID:DWORD;                    //clients handle
   PerDone:Byte;                  //computation progress
   Low,Hi:Integer;                //interval

   function IsPrime(N:Integer):Boolean;
   procedure WannaWork;
   procedure SendNetBuffer;
   procedure StartWorking;
   procedure SendPrimeNumber(Number:DWORD);
   procedure SendRangeDone;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.IsPrime(N:Integer):Boolean;
//the most important function in the programme ... checks whether
//N number is prime
//using very fast algorithm
var I:Integer;
begin
 I:=3;
 Result:=(N=2) or (N=3);
 if (N>3) and (N mod 2=1) then
 begin
  while (I<=Sqrt(N)) and (N mod I<>0) do
   Inc(I,2);
  Result:=N mod I<>0;
 end;
end; {IsPrime}

procedure TForm1.FormCreate(Sender: TObject);
//initialization
begin
 Port:=DefPort;
 Status:=sWaiting;
end; {FormCreate}

procedure TForm1.Button1Click(Sender: TObject);
//runs client, sets values
begin
 Port:=StrToIntDef(Edit2.Text,DefPort);
 Client.Port:=Port;

 with Client do
 begin
  Host:=Edit1.Text;
  Address:=Host;
  Active:=True;
 end;
end; {Button1Click}

procedure TForm1.ClientRead(Sender: TObject; Socket: TCustomWinSocket);
//handling of receiving data on socket
begin
 case Status of
  sWaiting:begin
   Socket.ReceiveBuf(NetBuffer,SizeOf(NetBuffer));
   with NetBuffer do
   case BType of
    btGetID:begin
     MyID:=D1;
     WannaWork;
    end;
    btHereIsYerWork:begin
     Low:=NetBuffer.D1;
     Hi:=NetBuffer.D2;
     StartWorking;
    end;
    btAllIsOver:begin
     Status:=sKill;
     Client.Close;
     Halt;
    end;
   end;
  end;
 end;
end; {ClientRead}

procedure TForm1.WannaWork;
//send buffer to the server with btWannaWork request
begin
 NetBuffer.ID:=MyID;
 NetBuffer.BType:=btWannaWork;
 SendNetBuffer;
end; {WannaWork}

procedure TForm1.SendNetBuffer;
//sends NetBuffer in itself
begin
 Client.Socket.SendBuf(NetBuffer,SizeOf(NetBuffer));
end; {SendNetBuffer}

procedure TForm1.StartWorking;
//checks the given range for prime numbers
var
 I,Count,Dv:Integer;
begin
 PerDone:=0;
 Label3.Caption:='Status: '+IntToStr(PerDone)+'% done';

 Dv:=(Hi+1)-Low;
 Count:=0;
 Label4.Caption:='Caunting '+IntToStr(Low)+' to '+IntToStr(Hi);

 for I:=Low to Hi do
 begin
  if IsPrime(I) then SendPrimeNumber(I);

  Inc(Count);
  PerDone:=Round(Count/Dv*100);
  Label3.Caption:='Status: '+IntToStr(PerDone)+'% done';
 end;

 SendRangeDone;
end; {StartWorking}

procedure TForm1.SendPrimeNumber(Number:DWORD);
//sends prime number to the server
begin
 with NetBuffer do
 begin
  ID:=MyID;
  BType:=btGetPrimeNumber;
  D1:=Number;
  SendNetBuffer;
 end;
end; {SendPrimeNumber}

procedure TForm1.ClientError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
//error handling
begin
 ErrorCode:=0;
 Halt;
end; {ClientError}

procedure TForm1.SendRangeDone;
//asks for a new work
begin
 with NetBuffer do
 begin
  ID:=MyID;
  BType:=btEndOfRange;
  SendNetBuffer;
  WannaWork;
 end;
end; {SendRangeDone}

procedure TForm1.ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
//all is over when server dies
begin
 Client.Close;
 Halt;
end; {ClientDisconnect}

end.
